var timer;

chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  // consolele.log(message);
  sendResponse({ message: "Hello from background" });
  if (message["method"] == "login_normal") {
    getLoginNormal(message["args"]);
  } else if (message["method"] == "send_sms") {
    getSendSms(message["args"]);
  } else if (message["method"] == "login_sms") {
    getLoginSms(message["args"]);
  } else if (message["method"] == "logout") {
    proxyClean();
  }
});
chrome.storage.onChanged.addListener(function (changes, namespace) {
  // for (var key in changes) {
  // var storageChange = changes[key];
  // // consolele.log(
  //   'Storage key "%s" in namespace "%s" changed. ' +
  //   'Old value was "%s", new value is "%s".',
  //   key,
  //   namespace,
  //   storageChange.oldValue,
  //   storageChange.newValue
  // );
  // }
});
function getLoginNormal(params) {
  loadingShow("flex");
  getPE(params, function (data) {
    // consolele.log(data);
    networkStart(data, params);
  });
}
function getSendSms(params) {
  getPE(params, function (data) {
    // consolele.log(data);
    getSms(data, params);
  });
}

function getPE(params, callback) {
  const company = params["company"];
  // const url = `https://dev-websase.7x-networks.net/${company}/provider_edges`;
  const url = `https://websase.7x-networks.net/${company}/provider_edges`
  fetch(url)
    .then((response) => response.json())
    .then((data) => {
      callback(data);
    })
    .catch((error) => {
      //再次调用 company返回default
      getPE({ company: "default" }, callback);
    });
}
// 获取短信验证码
function getSms(data, params) {
  let index = 0;
  const dataCount = data.length;

  // consolele.log(data);
  // consolele.log(params);
  function sendSms() {
    const element = data[index];
    let url = `${element["brower_api_url"]}/client/sms_code?cellphone=${params["cellphone"]}&customerName=${params["company"]}&internationalAreaCode=${params["internationalAreaCode"]}`;
    fetch(url, { method: "POST" })
      .then((response) => {
        const status = response.status;
        if (status == 200) {
          browerApiUrl = element["brower_api_url"];
          proxyHost = element["domain"];
          // consolele.log(response);
          toastShow("验证码发送成功", "success");
        } else {
          toastShow("验证码发送失败", "error");
          regetSmsCode()
        }
      })
      .catch((error) => {
        // consolele.log(error);
        index += 1;
        if (index >= dataCount) {
          toastShow("验证码发送失败", "error");
          regetSmsCode()
          return;
        }
        sendSms();
      });
  }

  sendSms();
}

//短信验证码登录
function getLoginSms(params) {
  if (!browerApiUrl) {
    toastShow("验证码错误,请重新获取验证码", "error");
    return
  }
  loadingShow("flex");
  var username = `${"%2B"}${params["area"]}${params["phone"]}@${params["company"]
    }`;
  var code = params["verification"];
  let url =
    browerApiUrl +
    `/oauth/token?client_id=browser&client_secret=JrORYwBTpLvR7MqM4xBzbnzDGIkFYFR4&grant_type=password&username=${username}&password=${code}`;
  fetch(url, { method: "POST" })
    .then((response) => {
      const status = response.status;
      // consolele.log(status)
      if (status == 200) {
        response.json().then((res) => {
          chrome.storage.session.set(
            { username: params["phone"] + "@" + params["company"] },
            function () {
              // consolele.log("Data saved");
            }
          );
          refreshTokenString = res["refresh_token"];

          getPortApp(
            `${browerApiUrl}/user/client/web/application_systems?access_token=${res["access_token"]}`
          );
        });
      } else if (status == 401) {
        loadingShow("none");
        response.json().then((res) => {
          toastShow(res["error_description"], "error");
        });
      }
    })
    .catch((error) => {
    });
}

// 账号密码登录
var refreshTokenString = "";
var browerApiUrl = "";
var proxyHost = ""
function networkStart(data, params) {
  let index = 0;
  const dataCount = data.length;
  //账号密码登录获取token
  function getToken() {
    const element = data[index];
    let url = `${element["brower_api_url"]}/oauth/token?password=${params["password"]
      }&username=${params["username"] + "@" + params["company"]
      }&client_secret=JrORYwBTpLvR7MqM4xBzbnzDGIkFYFR4&client_id=browser&grant_type=password`;
    fetch(url, { method: "POST" })
      .then((response) => {
        const status = response.status;
        // consolele.log(status)
        if (status == 200) {
          response.json().then((res) => {
            // consolele.log(res);
            browerApiUrl = element["brower_api_url"];
            proxyHost = element["domain"];
            refreshTokenString = res["refresh_token"];
            chrome.storage.session.set(
              { username: params["username"] + "@" + params["company"] },
              function () {
                // consolele.log("Data saved");
              }
            );
            getPortApp(
              `${element["brower_api_url"]}/user/client/web/application_systems?access_token=${res["access_token"]}`
            );
          });
        } else if (status == 403) {
          loadingShow("none");
          chrome.runtime.sendMessage(
            {
              method: "twoStep",
            },
            (res) => {
              // consolele.log("receive");
              // consolele.log(res);
            }
          );
        } else if (status == 401) {
          loadingShow("none");
          response.json().then((res) => {
            toastShow(res["error_description"], "error");
          });
        } else {
          index += 1;
          if (index >= dataCount) {
            return;
          }
          getToken();
        }
      })
      .catch((error) => {
        index += 1;
        if (index >= dataCount) {
          return;
        }
        getToken();
      });
  }

  getToken();
}

// 获取应用列表
function getPortApp(url) {
  fetch(url)
    .then((response) => response.json())
    .then((data) => {
      // consolele.log('getPortApp')
      loadingShow("none");
      refreshToken();

      proxySet(data);

      chrome.runtime.sendMessage(
        {
          method: "login_success",
          args: {
            applicationSystemList: data.applicationSystemList,
          },
        },
        (res) => {
          // consolele.log("receive");
          // consolele.log(res);
        }
      );
    })
    .catch((error) => {
      // consolele.log(error);
    });
}

function refreshToken() {
  let url =
    browerApiUrl +
    `/oauth/token?client_id=browser&client_secret=JrORYwBTpLvR7MqM4xBzbnzDGIkFYFR4&grant_type=refresh_token&refresh_token=${refreshTokenString}`;
  timer = setInterval(() => {
    fetch(url)
      .then((response) => response.json())
      .then((data) => {
        // consolele.log(data);
        refreshTokenString = data["refresh_token"];
      })
      .catch((error) => {
        proxyClean();
        // consolele.log(error);
      });
  }, 300000);
}

chrome.proxy.onProxyError.addListener((callback) => {
  // consolele.log(callback);
});
chrome.runtime.onInstalled.addListener(() => {
  proxyClean();
  // consolele.log("后台脚本运行成功");
});

if (chrome.windows.onRemoved) {
  chrome.windows.onRemoved.addListener(function (windowId) {
    console.log("windowId", windowId);
    chrome.windows.getAll(function (windows) {
      if (windows.length <= 0) {
        // 所有窗口都关闭了，删除存储的数据
        proxyClean();
      }
    });
  });
} else {
  chrome.runtime.onSuspend.addListener(function () {
    // 在浏览器关闭或调试窗口关闭时执行清理逻辑
    chrome.windows.getAll(function (windows) {
      if (windows.length <= 0) {
        // 所有窗口都关闭了，删除存储的数据
        proxyClean();
      }
    });
  });
}

function proxyClean() {
  if (timer) {
    clearInterval(timer);
  }
  chrome.storage.session.remove(["refresh_token", "username"], function () {
    // consolele.log("Data removed");
  });
  chrome.storage.local.remove(["applicationSystemList"], function () {
    // consolele.log("Data removed");
  });
  chrome.proxy.settings.clear(
    {
      scope: "regular",
    },
    function () {
      // consolele.log("Proxy settings cleared.");
    }
  );
}
//过滤出一级域名、二级域名
function filterDomain(url) {
  if (typeof url !== "string" || url.replaceAll(" ", "").length === 0) {
    return "";
  }
  const regex = /^(?:https?:\/\/)?([^:\/\n]+)/;
  const match = regex.exec(url);
  let domain = match[1];
  return domain;
}
function proxyGet() {
  chrome.proxy.settings.get({ incognito: false }, function (config) {
    // consolele.log(JSON.stringify(config));
  });
}
function proxySet(data) {
  const server = `return 'HTTPS ${proxyHost}:${data.httpsProxyPort}';\n`;
  var str = "function FindProxyForURL(url, host) {\n";
  data.applicationSystemList.map((item) => {
    const domainUrl = filterDomain(item.url);
    str += `if (host == "${domainUrl}")\n`;
    str += server;
  });
  str += "return 'DIRECT';\n";
  str += "}";

  console.log(str);
  // var sss = ['*.blog.csdn.net/', 'git.7x-networks.net', '*.zhidao.baidu.com/', '*.baidu.com']

  // sss.map((item) => {
  //   str += `if (host.replace(/./, '(?:^|\\.)').replace(/\.\*\$$/, ''))\n`
  //   str += "return 'HTTPS dev-sase-pop1.7x-networks.net:10002';\n"
  // })
  // str += "return 'DIRECT';\n"
  // str += "}"

  // var str = "function FindProxyForURL(url, host) {\n" +
  //   "if (host == 'git.7x-networks.net')\n" +
  //   "return 'HTTPS dev-sase-pop1.7x-networks.net:10002';" +
  //   "if (host == 'baidu.com')\n" +
  //   "return 'HTTPS dev-sase-pop1.7x-networks.net:10002';" +
  //   // "  return 'DIRECT';\n" +
  //   "}"
  // var str = `function FindProxyForURL(url, host) {
  //   if (/(?:^|\.)7x-networks\.net$/.test(host)) return "HTTPS dev-sase-pop1.7x-networks.net:10002";
  //       if (/(?:^|\.)baidu\.com$/.test(host)) return "HTTPS dev-sase-pop1.7x-networks.net:10002";
  //       return "DIRECT"
  // }`

  // var sss = ['git.7x-networks.net', 'gitee.com/chinaio']
  // var sss = 'tss.7x-networks.net,git.7x-networks.net'
  // var sss = 'git.7x-networks.net'

  // a.applicationSystemList.map((item) => {
  //   str += `if ('host' == ${item.url})\n`
  //   str += "return 'HTTPS dev-sase-pop1.7x-networks.net:10002';\n"
  //   // // consolele.log(str)
  // })

  var config = {
    mode: "pac_script",
    pacScript: {
      data: str,
      // `function FindProxyForURL(url, host) {
      //   if (host == 'git.7x-networks.net')
      //     return 'HTTPS dev-sase-pop1.7x-networks.net:10002';
      //   return 'DIRECT';
      // }`
    },
  };
  chrome.proxy.settings.set(
    {
      value: config,
      scope: "regular",
    },
    function () { }
  );
}

function toastShow(message, method = "success") {
  chrome.runtime.sendMessage(
    {
      method: "toast",
      args: {
        message: message,
        method: method,
      },
    },
    (res) => {
      // consolele.log("receive");
      // consolele.log(res);
    }
  );
}

function loadingShow(method) {
  chrome.runtime.sendMessage(
    {
      method: "loading",
      args: {
        method: method,
      },
    },
    (res) => {
      // consolele.log("receive");
      // consolele.log(res);
    }
  );
}

function regetSmsCode() {
  chrome.runtime.sendMessage(
    {
      method: "regetSmsCode",
    },
    (res) => {
    }
  );
}
