chrome.extension.getViews({ type: "popup" }).forEach(function (view) {
  // 检查popup是否打开
  if (view.location.href === chrome.runtime.getURL("popup.html")) {
    reloadUserName();
  }
});

function reloadUserName() {
  chrome.storage.session.get(["username"], function (result) {
    // console.log("Value currently is " + result.username);
    if (result.username != null) {
      $(".phoneType").css("display", "none");
      $(".loginSuccess").css("display", "revert");
      $(".accountType").css("display", "none");
      $(".usernameTitle").text(result.username);

      chrome.storage.local.get(["applicationSystemList"], function (result) {
        // console.log("result", result);
        getTabUrl(result);
      });
    }
  });
}

//渲染区号
const areaDom = () => {
  var dom = "";
  prefixSorted.forEach((area) => {
    dom += `<option value='${area.prefix}'>+${area.prefix}</option>`;
  });
  $(".area").html(dom);
};
areaDom();

var isSmsLogin = false;
$(".accountClick").click(function (event) {
  isSmsLogin = false;
  $(".accountType").css("display", "revert");
  $(".phoneType").css("display", "none");
  $(".smsClick").removeClass("clickTitleColor");
  $(".accountClick").addClass("clickTitleColor");
});
$(".smsClick").click(function (event) {
  isSmsLogin = true;
  $(".phoneType").css("display", "revert");
  $(".accountType").css("display", "none");
  $(".accountClick").removeClass("clickTitleColor");
  $(".smsClick").addClass("clickTitleColor");
});
$(".gobackButton").click(function (event) {
  $(".accountType").css("display", "revert");
  $(".loginSuccess").css("display", "none");
  $(".phoneType").css("display", "none");

  chrome.runtime.sendMessage(
    {
      method: "logout",
    },
    (res) => {
      // console.log("receive");
      // console.log(res);
    }
  );
});
$(".codeBg").click(function (event) {
  if (event.target.nodeName !== "INPUT") return;
  currentFocus(Number(event.target.dataset.num));
});
$(".backClick").click((e) => {
  $(".accountType").css("display", "revert");
  $(".twoStep").css("display", "none");
});
$(".loginButton").click((e) => {
  if (isSmsLogin) {
    if ($(`.company`).val().replaceAll(" ", "").length == 0) {
      noticeHandle("企业号不能为空", "warn");
      return;
    } else if ($(`.phone`).val().replaceAll(" ", "").length == 0) {
      noticeHandle("手机号不能为空", "warn");
      return;
    } else if ($(`.verification`).val().replaceAll(" ", "").length == 0) {
      noticeHandle("验证码不能为空", "warn");
      return;
    }
  } else {
    if ($(`.company`).val().replaceAll(" ", "").length == 0) {
      noticeHandle("企业号不能为空", "warn");
      return;
    } else if ($(`.password`).val().replaceAll(" ", "").length == 0) {
      noticeHandle("密码不能为空", "warn");
      return;
    } else if ($(`.username`).val().replaceAll(" ", "").length == 0) {
      noticeHandle("用户名不能为空", "warn");
      return;
    }
  }
  chrome.runtime.sendMessage(
    {
      method: isSmsLogin ? "login_sms" : "login_normal",
      args: isSmsLogin
        ? {
          phone: $(`.phone`).val().replaceAll(" ", ""),
          area: $(`.area`).val(),
          verification: $(`.verification`).val(),
          company: $(`.company`).val(),
        }
        : {
          username: $(`.username`).val(),
          password: $(`.password`).val(),
          company: $(`.company`).val(),
        },
    },
    (res) => {
      // console.log("receive");
      // console.log(res);
    }
  );
});

chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message["method"] == "login_success") {
    $(".phoneType").css("display", "none");
    $(".loginSuccess").css("display", "revert");
    $(".accountType").css("display", "none");
    reloadUserName();
    getTabUrl(message["args"]);
  } else if (message["method"] == "twoStep") {
    $(".accountType").css("display", "none");
    $(".loginSuccess").css("display", "none");
    $(".twoStep").css("display", "revert");
  } else if (message["method"] == "loading") {
    handleLoading(message["args"]["method"]);
  } else if (message["method"] == "toast") {
    noticeHandle(errors[message["args"]["message"]] ? errors[message["args"]["message"]] :
      message["args"]["message"], message["args"]["method"]);
  } else if (message["method"] == "regetSmsCode") {
    regetSmsCode()
  }
  // console.log(message);
  sendResponse({ message: "Hello from popup.js" });
});

function getTabUrl({ applicationSystemList }) {
  //渲染登录成功后应用列表
  if (Array.isArray(applicationSystemList)) {
    let dom = "";
    (applicationSystemList || []).forEach((item) => {
      chrome.storage.local.set({
        applicationSystemList: applicationSystemList ?? [],
      });
      const iconNameOrImg = item.icon
        ? `<img class="web_icon" src="${"data:image/jpeg;base64," + item.icon
        }"/>`
        : `<span class="imgName">${item?.name}</span>`;
      dom += `<div class="appCount" data-url=${item?.url}>
                      <button class="appButton">${iconNameOrImg}</button>
                      <span class="appTitle">${item?.name}</span>
                  </div>`;
    });
    $(".appCountDiv").html(dom);
  }
}

//点击图标跳转到相关链接
$(".appCountDiv").on("click", ".appCount", function (e) {
  e.stopImmediatePropagation();
  if (e?.currentTarget?.nodeName != "DIV") return;
  //获取iframe的id
  const url = e?.currentTarget.getAttribute("data-url");
  //点击打开新的tab页面
  // console.log("url", url); //'baidu.com'
  chrome.tabs.create({ url: url });
});

var codeInterval = null;
$(".verificationButton").click((event) => {
  event.preventDefault();

  var enterpriseAccountCode = $(".company").val();
  var phoneNumber = $(".phone").val().replaceAll(" ", "");
  var areaCode = $(".area").val();
  if (!removeBlankSpace(enterpriseAccountCode))
    return noticeHandle("企业号不能为空！", "warn");
  if (!removeBlankSpace(phoneNumber))
    return noticeHandle("手机号不能为空！", "warn");
  $(".verificationButton").attr("disabled", true);
  var countDown = 60;
  codeInterval = setInterval(() => {
    if (countDown == 0) {
      regetSmsCode()
      return;
    }
    $(".verificationButton").text(String(countDown) + "s");
    countDown -= 1;
    // console.log(countDown);
  }, 1000);

  chrome.runtime.sendMessage(
    {
      method: "send_sms",
      args: {
        cellphone: phoneNumber,
        company: enterpriseAccountCode,
        internationalAreaCode: areaCode,
      },
    },
    (res) => { }
  );
  return false;
});

const regetSmsCode = () => {
  $(".verificationButton").text("重新获取");
  // $(".verificationButton").text(pages.phoneCodeReset);
  $(".verificationButton").attr("disabled", false);
  clearInterval(codeInterval);
}

var focusNum = []; //获取焦点项
var isRemberFocus = (domNum) => {
  focusNum.includes(domNum) ? "" : focusNum.push(domNum);
};
const checkInputIsCompleted = () => {
  var nums = new Array(6).fill(0);
  var inputsVal = [];
  nums.forEach((itm, index) => {
    const val = $(`.attestation_code_input_${index + 1}`).val();
    inputsVal.push(val);
    if (!removeBlankSpace(val)) isNone = false;
  });
  if (!inputsVal.includes("")) {
    var secondCode = inputsVal.join("");
    $(".attestation")
      .removeClass("attestation_show")
      .addClass("attestation_hide");
    //将输入框值进行初始化
    nums.forEach((item, index) => {
      $(`.attestation_code_input_${index + 1}`).val(undefined);
    });
    accountSubmit(secondCode);
  }
};
const accountSubmit = (secondCode) => {
  // console.log(secondCode);
  $(".accountType").css("display", "revert");
  $(".twoStep").css("display", "none");

  chrome.runtime.sendMessage(
    {
      method: "login_normal",
      args: {
        username: $(`.username`).val(),
        password: $(`.password`).val() + "-" + secondCode,
        company: $(`.company`).val(),
      },
    },
    (res) => {
      // console.log("receive");
      // console.log(res);
    }
  );
};
//聚焦下一项
const nextFocus = (num) => {
  checkInputIsCompleted();
  if (num > 6) return;
  $(`.attestation_code_input_${num}`).focus();
  currentFocus(Number(num));
};
const currentFocus = (num) => {
  if (num > 6) num == 1;
  if (!focusNum.includes(num)) {
    $(`.attestation_code_input_${num}`).on("input", (event) => {
      if (event.target.value != "") {
        nextFocus(Number(num) + 1);
      }
    });
    $(`.attestation_code_input_${num}`).on("keydown", (event) => {
      if (event.keyCode == 8) {
        if (event.currentTarget.value == "") {
          nextFocus(Number(num) - 1);
        } else {
          nextFocus(Number(num));
        }
      }
    });
  }
  isRemberFocus(num);
};

var errors = {
  unknown: "内部错误",
  E001: "连接失败！错误代码：E001 内部错误",
  E002: "连接失败！错误代码：E002 企业号/用户名/密码错误，请检查",
  E003: "连接失败！错误代码：E003 验证码错误，请重新输入",
  E004: "连接失败！错误代码：E004 内部错误",
  E005: "连接失败！错误代码：E005 内部错误",
  E006: "连接失败！错误代码：E006 内部错误",
  E007: "连接失败！错误代码：E007 内部错误",
  E008: "连接失败！错误代码：E008 内部错误",
  E009: "连接失败！错误代码：E009 请在授权区域登录",
  E010: "连接失败！错误代码：E010 您的账户被锁定，请联系管理员",
  E011: "连接失败！错误代码：E011 您的账户已过期，请联系管理员",
  E012: "连接失败！错误代码：E012 短信验证码错误，请重新输入",
  E013: "发送失败！错误代码：E013 短信验证码获取失败，请重试",
  E014: "发送失败！错误代码：E014 企业号/手机号错误，请检查",
};
