//弹出提示框
var noticeStatus = null;
var noticeClass = {
  success: "notice_success",
  warn: "notice_warn",
  error: "notice_error",
};

const noticeHandle = (
  text = "操作成功",
  status = "success",
  ifRemove = true
) => {
  if (noticeStatus) clearTimeout(noticeStatus);
  $(".notice_tips").text(text);
  $("#notice_icon_id").removeClass();
  $("#notice_icon_id").addClass(noticeClass[status ?? "success"]);
  $(".notice").css("display", "flex");
  // $(".notice").addClass("notice_active");
  noticeStatus = setTimeout(() => {
    if (ifRemove) $(".notice").css("display", "none");
  }, 2000);
};

//清除所有空格
const removeBlankSpace = (val) =>
  typeof val === (undefined || null) ? "" : String(val).replaceAll(" ", "");

//获取url query
const getQueryString = (name) => {
  var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
  var r = window.location.search.substr(1).match(reg);
  if (r != null) return unescape(r[2]);
  return null;
};

//创建不可点击的遮罩层
const createMask = (opa = "mask") => {
  //禁止点击
  var maskDom = document.createElement("div");
  maskDom.className = opa;
  document.body.appendChild(maskDom);
};

//判断当前浏览器是否开启了无痕模式
var detectPrivateMode = async (callback) => {
  var isPrivate = false;

  // Check for private browsing mode in Safari
  if (window.webkitRequestFileSystem) {
    window.webkitRequestFileSystem(
      window.TEMPORARY,
      1,
      function () {
        isPrivate = false;
      },
      function (e) {
        isPrivate = true;
        createMask();
      }
    );
  }

  // Check for private browsing mode in Firefox
  if (typeof InstallTrigger !== "undefined") {
    function isPrivateMode() {
      return new Promise(function (resolve, reject) {
        const db = indexedDB.open("test");

        db.onerror = function () {
          return resolve(true);
        };

        db.onsuccess = function () {
          return resolve(false);
        };
      });
    }
    var isPri = await isPrivateMode();
    if (isPri) {
      createMask();
      isPrivate = true;
    } else {
      isPrivate = false;
    }
  }

  // Check for private browsing mode in Chrome and Edge
  if (
    window.navigator.userAgent.indexOf("Edge") > -1 ||
    window.navigator.userAgent.indexOf("Chrome") > -1
  ) {
    try {
      window.localStorage.setItem("test", "test");
      window.localStorage.removeItem("test");
    } catch (e) {
      isPrivate = true;
      createMask();
    }
  }

  // Execute the callback function with the boolean value
  if (callback) {
    callback(isPrivate);
  }
};

//根据浏览器选择语言环境
const local = function (callback, ...languages) {
  var browserLang = navigator.language;
  var index = 0; //选择的语言下标
  if (browserLang.includes("zh-CN")) {
    //简体中文
    index = 0;
    callback(languages[0]);
  } else if (browserLang.includes("zh-TW")) {
    //繁体中文
    callback(languages[1]);
    index = 1;
  } else {
    //英文
    callback(languages[2]);
    index = 2;
  }
  // console.log(navigator);
  // console.log(browserLang);
  const { errors, inputTips, notice, pages } = languages[index];
  return { browserLang, errors, inputTips, notice, pages };
};

//获取浏览器内核版本
function getBroswer() {
  var sys = {};
  var ua = navigator.userAgent.toLowerCase();
  var s;
  (s = ua.match(/edge\/([\d.]+)/)) ? sys.edge = s[1] :
    (s = ua.match(/rv:([\d.]+)\) like gecko/)) ? sys.ie = s[1] :
      (s = ua.match(/msie ([\d.]+)/)) ? sys.ie = s[1] :
        (s = ua.match(/firefox\/([\d.]+)/)) ? sys.firefox = s[1] :
          (s = ua.match(/chrome\/([\d.]+)/)) ? sys.chrome = s[1] :
            (s = ua.match(/opera.([\d.]+)/)) ? sys.opera = s[1] :
              (s = ua.match(/version\/([\d.]+).*safari/)) ? sys.safari = s[1] : 0;

  if (sys.edge) return { broswer: "Edge", version: sys.edge };
  if (sys.ie) return { broswer: "IE", version: sys.ie };
  if (sys.firefox) return { broswer: "Firefox", version: sys.firefox };
  if (sys.chrome) return { broswer: "Chrome", version: sys.chrome };
  if (sys.opera) return { broswer: "Opera", version: sys.opera };
  if (sys.safari) return { broswer: "Safari", version: sys.safari };

  return { broswer: "", version: "0" };
}

//判断当前浏览器是否可以使用该功能
const browserIsSupported = () => {
  //判断该当前浏览器是否开启了隐私模式,以及当前浏览器内核是否为80版本
  detectPrivateMode(function (isPrivate) {
    if (isPrivate) {
      noticeHandle("请关闭隐私模式之后使用该功能！", "warn", false);
    }
  });
  const { broswer, version } = getBroswer()
  const firstVersion = version.split('.')[0]
  //判断当前浏览器内核是否支持，必须大于Chrome/80.0.3987.87这个版本
  if (broswer.toLowerCase().indexOf('chrome') > -1) {
    // console.log("当前浏览器内核过低，请更换浏览器");
    if (firstVersion <= 80) {
      createMask();
      noticeHandle("当前浏览器内核版本过低，请更换浏览器！", "warn", false);
    }

  }
};

/**
 * loading是否展示
 * @param {'none'|'revert'} type 是否关闭loading 默认none
 * @param {boolean} isFail 是否显示无法打开页面 默认false
 */
let clearLoadingTime = null;
var handleLoading = (type = 'none', second = 2000) => {
  $('.right_bac').css("display", type)
  $(".loading_box").css('display', type)
  if (type == 'none') return
  if (clearLoadingTime) clearTimeout(clearLoadingTime)
  clearLoadingTime = setTimeout(() => {
    handleLoading('none');
    clearTimeout(clearLoadingTime)
  }, second)
};

//是否显示无法发开网页默认图片
var webIsFailShow = (type) => {
  $('.web_isfail').css({ 'display': type ? 'flex' : 'none', zIndex: type ? 102 : -1 });
  $(".x_tabs").css({ display: type ? 'none' : 'revert' });
}

//关闭掉所有的tab，显示初始化默认图片
var showDefaultImg = (defaultType = 'none', tabType = true) => {
  $('.right_bac').css("display", defaultType)
  $(".x_tabs").css({ display: tabType ? 'none' : 'revert' });
}

/**
 * 判断当前选择产品是否是禁止打开的
 * @param {number|string} iframeId 当前选择的iframe id
 * @returns boolean 禁止打开为true，反之为false
 */
var webIsInvalid = (iframeId) => {
  //页面是否失效
  let isInvalid = false;
  (iframesObj || []).forEach(iframe => {
    if (iframe.id == iframeId && iframe.Forbidden) {
      isInvalid = true
    } else {
      const isCurrent = iframeId > Number(iframe.id) && iframeId < (Number(iframe.id) + 100);
      if (isCurrent) {
        iframe.currentTabsId.forEach(item => {
          if (item.id == iframeId && item.Forbidden) {
            isInvalid = true
          }
        })
      }
    }
  });
  return isInvalid
}